package com.sd.business.service.work.impl.fixation;

import com.sd.business.entity.work.constant.MaterialsConstant;
import lombok.Getter;

import java.math.BigDecimal;

public abstract class FixationStrategy {

    /**
     * 卷材长度
     */
    protected final BigDecimal masterLength = new BigDecimal(MaterialsConstant.MASTER_LENGTH);

    /**
     * 卷材宽度
     */
    protected final BigDecimal masterWidth = new BigDecimal(MaterialsConstant.MASTER_WIDTH);

    /**
     * 卷材面积
     */
    protected final BigDecimal masterArea = masterLength.multiply(masterWidth);

    /**
     * 是否可以继续排版
     */
    protected Boolean hasNext = true;

    /**
     * 排版参数
     */
    @Getter
    private TypeSettingBo typeSettingBo;

    /**
     * 获取下一个排版信息
     */
    public abstract TypeSettingBo next();

    /**
     * 是否有下一个排版信息
     */
    public boolean hasNext() {
        return this.hasNext;
    }

    /**
     * 赋值下一个排版信息
     */
    protected void setTypeSettingBo(TypeSettingBo typeSettingBo) {
        this.typeSettingBo = typeSettingBo;
    }

}
