package com.sd.business.service.work.impl.fixation;

import com.sd.business.entity.work.constant.MaterialsConstant;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * 排版参数
 */
@Getter
@AllArgsConstructor
public class TypeSettingBo {

    /**
     * 卷材面积
     */
    private BigDecimal masterArea;

    /**
     * 已使用面积
     */
    private BigDecimal usedArea;

    /**
     * 排单数量
     */
    private BigDecimal schedulingNum;

    /**
     * x轴坐标
     */
    private BigDecimal x;

    /**
     * y轴坐标
     */
    private BigDecimal y;

    /**
     * 长（考虑旋转后的）
     */
    private BigDecimal length;

    /**
     * 宽（考虑旋转后的）
     */
    private BigDecimal width;

    /**
     * 最大长度
     */
    private BigDecimal maxLength;

    /**
     * 是否旋转
     */
    private Boolean hasRotate;

    /**
     * 获取使用率
     */
    public final BigDecimal getUseRatio() {
        return usedArea.multiply(new BigDecimal(100)).divide(masterArea, 2, RoundingMode.HALF_UP);
    }

    /**
     * 获取出血长度
     */
    public final BigDecimal getBleedingLength() {
        return this.length.add(BigDecimal.valueOf((MaterialsConstant.RESERVE)));
    }

    /**
     * 获取出血宽度
     */
    public final BigDecimal getBleedingWidth() {
        return this.width.add(BigDecimal.valueOf((MaterialsConstant.RESERVE)));
    }

}
